// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////

#pragma once

/// Moving circle that is contained in the model. A ball is a circle
/// with an associated velocity.
class CBall : public UWBD3D_CircleGeometry
{
public:
  CBall();

  vec3 GetVelocity() const;
  void SetVelocity(const vec3& velocity);

  /// \return true if this ball is outside of a region.
  /// \param bounds_width, bounds_height [in]: range to check to see if the
  ///        ball is inside of
  bool IsOutsideBounds( float bounds_width, float bounds_height) const;

private:
  vec3 m_velocity;
};
