#include "StdAfx.h"
#include "Model.h"


CModel::CModel()
: m_WorldWidth(0.0f)
, m_WorldHeight(0.0f)
, m_ShouldSlowDown(false)
{
  m_Ball.SetCenter( 100 ,  25 );
  m_Ball.SetRadius( kBallSize );
  m_Ball.SetVelocity(vec3(0.0f,0.0f,0.0f));

  m_Guide.SetFillColor(UWB_Color(1.0f, 0.0f, 0.0f) );
  m_Guide.SetRadius(5.0f);

}

void CModel::SetWorldSize(float width, float height)
{
  m_WorldWidth = width;
  m_WorldHeight = height;
}

void CModel::GetWorldSize(float& width, float& height) const
{
  width = m_WorldWidth;
  height = m_WorldHeight;
}

void CModel::SetHeroBallVelocity(const vec3& v)
{
  m_Ball.SetVelocity(v);
  m_ShouldSlowDown = false;
}

void CModel::SetHeroBallPosition(const vec3& p)
{
  m_Ball.SetCenter(p);
}

void CModel::SetGuidePosition(const vec3 &p)
{
  m_Guide.SetCenter(p);
}

void CModel::DrawModel()
{
  m_Ball.Draw();
  m_Guide.Draw();
}