#include "StdAfx.h"
#include "Model.h"


void CModel::UpdateABall(CBall &b, float elapsed_seconds)
{
  float r =  b.GetRadius();
  vec3 center = b.GetCenter();
  vec3 v = b.GetVelocity();
  float speed = length(v);
  
  if ( (speed > VERY_SLOW) || (center.y > (RADIUS_TOL*r)) ){
	  
	  // update ball position
	  vec3 update_vector = v * elapsed_seconds;
	  center = center + update_vector;
	  
	  // check bounds
	  if (center.x > (m_WorldWidth-r)) {
		  // must bounce!
		  v.x *= -1.0f;
		  center.x = m_WorldWidth-r;
	  } else {
          if (center.x < r) {
              v.x *= -1.0f;
              center.x = r;
          }
      }

      if (center.y > (m_WorldHeight-r)) {
            v.y *= -1.0f;
            center.y = m_WorldHeight-r;
      } else {
            if (center.y < r) {
                center.y = r;
                v.y *= -1.0f;
            }
      }

      float speed = length(v);
      float acceleration = 1.05f;
      if (speed > 1000.0f)
          m_ShouldSlowDown = true;
      
      if (m_ShouldSlowDown)
          acceleration = 0.9f;

      v = speed * acceleration * normalize(v);

	  b.SetCenter(center);
	  b.SetVelocity(v);
  }
}

void CModel::UpdateSimulation()
{
  float elapsed_seconds = m_stop_watch.GetSecondsElapsed();
  UpdateABall(m_Ball, elapsed_seconds);
}