#include "stdafx.h"
#include "TutorialApp.h"
#include "TutorialDlg.h"

// DEBUG_NEW macro allows MFC applications to determine memory leak locations in debug builds
#ifdef _DEBUG
  #define new DEBUG_NEW
#endif


CSpeedAndVelocityDlg::CSpeedAndVelocityDlg(CWnd* pParent)
: CDialog(CSpeedAndVelocityDlg::IDD, pParent)
{
  m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CSpeedAndVelocityDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSpeedAndVelocityDlg, CDialog)
  ON_WM_PAINT()
  ON_WM_DESTROY()
  ON_WM_TIMER()
  END_MESSAGE_MAP()

// This is called when the dialog is first created and shown.
// It is a good spot to initialize member variables.
BOOL CSpeedAndVelocityDlg::OnInitDialog()
{
  CDialog::OnInitDialog();

  // Set the icon for this dialog.  The framework does this automatically
  //  when the application's main window is not a dialog
  SetIcon(m_hIcon, TRUE);   // Set big icon
  SetIcon(m_hIcon, FALSE);  // Set small icon

  // initialize the Direct3D Graphics system
  if( !UWBD3D_GraphicsSystem::GetSystem().CreateGraphicsContext(m_hWnd) )
    return FALSE;

  if( !m_view.Initialize(*this, IDC_PLACEHOLDER) )
    return FALSE;

  CRect rect;
  m_view.GetWindowClientRect(rect);
  theApp.GetModel().SetWorldSize((float)rect.Width(), (float)rect.Height());

  CWnd* pWnd = GetDlgItem(IDC_STATUS);
  if(pWnd)
    UWB_hEchoWindow = pWnd->m_hWnd;

  // Here we initialize the timer, to go off every 25 milli seconds
  // when timer "goes-off", our OnTimer() function will be called and
  // it is up to us to decide what we want to do.
  int msInterval = 25; // timer going off every 25 milli seconds.
  SetTimer(0, msInterval, NULL);    // our goal is to approx 40 frames per second


  return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CSpeedAndVelocityDlg::OnPaint() 
{
  if (IsIconic())
  {
    CPaintDC dc(this); // device context for painting

    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    // Center icon in client rectangle
    int cxIcon = GetSystemMetrics(SM_CXICON);
    int cyIcon = GetSystemMetrics(SM_CYICON);
    CRect rect;
    GetClientRect(&rect);
    int x = (rect.Width() - cxIcon + 1) / 2;
    int y = (rect.Height() - cyIcon + 1) / 2;

    // Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
  {
    CDialog::OnPaint();
  }
}

void CSpeedAndVelocityDlg::OnDestroy()
{
  UWBD3D_GraphicsSystem::GetSystem().ShutDown();
  CDialog::OnDestroy();
}

void CSpeedAndVelocityDlg::OnTimer(UINT nIDEvent)
{
  //update the model state
  theApp.GetModel().UpdateSimulation();

  //Draw the view that shows our model
  m_view.DrawGraphics();
}