// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "DrawAndMouseHandler.h"

/// Main dialog for the sample application. This is created and displayed in
/// the CSpeedAndVelocityApp::InitInstance function.
class CSpeedAndVelocityDlg : public CDialog
{
public:
  CSpeedAndVelocityDlg(CWnd* pParent = NULL);

  /// The IDD enum is a common technique in MFC to associate a dialog with
  /// a resource that you edit in the dialog editor
  enum { IDD = IDD_SPEEDANDVELOCITY_DIALOG };

protected:
  /// Called immediately after a dialog is created, but before it is displayed.
  /// This is where all of the control initialization usually occurs. This is
  /// also where the graphics window is set up
  virtual BOOL OnInitDialog();
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

  /// A message map is an MFC macro for mapping window's events (paint, size, mouse,...) that
  /// occur on a window to functions in this class.
  /// The functions in this class that begin with afx_msg are "handlers" for window's messages
  DECLARE_MESSAGE_MAP()

  /// Called when this dialog receives a WM_PAINT message (event)
  /// The MFC wizard adds code to paint properly if this dialog is minimized to the taskbar
  afx_msg void OnPaint();

  /// Called when this dialog receives a WM_DESTROY message (event)
  /// This is where the dialog releases all of the Direct3D resources it is using
  afx_msg void OnDestroy();

  /// Called when this dialog receives a WM_TIMER message (event)
  /// For our graphics applications to continually redraw, we use a timer
  afx_msg void OnTimer(UINT nIDEvent);

  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

private:
  CDrawAndMouseHandler   m_view;
  HICON m_hIcon;

public:

};
