// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

#pragma once
#include "uwbgl_Common.h"
#include <time.h>

/// Stop-Watch type timer class. For animation/simulation, it is important
/// to determine how much time has elapsed since the last frame.
class UWB_Clock
{
public:
  /// Start the clock ticking, the next call to GetSecondsElapsed() will return the number
  /// of seconds elapsed since the creation of the clock.
  UWB_Clock();

  ///
  /// Seconds elapsed since the last call to this function.
  float GetSecondsElapsed();

private:
  ///
  /// The previous time the clock was consulted
  clock_t m_previous_update_time;
};
