// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DDefines.h"

///
/// Represents a 2-dimensional rectangle that can be drawn to a graphics window
class UWBD3D_RectangleGeometry
{
public:
  /// Default rectangle is centered at 0,0
  /// and has a size of 0
  UWBD3D_RectangleGeometry();

  void SetCenter( vec3 center);
  void SetSize(float width, float height);

  /// Draw this rectangle to a graphics window
  /// if the rectangle is valid
  void Draw() const;

protected:
  // geometric definition of the rectangle
  vec3 m_center;
  float m_width;
  float m_height;
};
