// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_D3DDefines.h"
#include "uwbgl_WindowHandler2.h"

///
/// Direct3D Specific graphics window handler.
class UWBD3D_WindowHandler : public UWB_WindowHandler
{
public:
  UWBD3D_WindowHandler();
  virtual ~UWBD3D_WindowHandler();

  /// \return true if this handler has a connection to a Direct3D device
  ///         for drawing to
  virtual bool IsGraphicsDeviceValid();

  /// Create a connection to a Direct3D device for drawing to
  /// \return true on success
  virtual bool InitializeHandler(HWND hAttachedWindow);

  ///
  /// Release connection to a Direct3D device
  virtual void ShutDownHandler();

  ///
  /// Called at the beginning of drawing a frame
  virtual void BeginDraw();

  ///
  /// Called at the end of drawing a frame
  virtual void EndDrawAndShow();

protected:
  LPDIRECT3DDEVICE9       m_pD3DDevice;  // This is the link to the D3D Device
  LPDIRECT3DSWAPCHAIN9    m_pSwapChain;  // the swap chain.
  LPDIRECT3DSURFACE9      m_pDrawSurface;
};
