// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
///////////////////////////////////////////////////////////////////////////////////

/// uwbgl_D3D_Lib3.h - Main Include file for version 3 of the UWB Direct3D Graphics Library
/// Include this single header file in your projects to add support for the library.

/// NOTE: There is absolutely no library specific windowing functionality in this library
///       Include the MFC UWBGL library (or other UWBGL windowing library) into your projects
///       to add windowing support.

/// *IMPORTANT*: Header and source files in UWBGL_Direct3D_1 should NEVER include this file.
/// *IMPORTANT*: External projects that use this library should ONLY include this file to get
///              access to all class and functions provided by this library.
#pragma once

#include "uwbgl_D3DDefines.h"       //Direct3D Specific headers and linking instructions

#include "math3d++/math3d++.h"      // math library
using namespace math3d;

#include "uwbgl_Common.h"             //Common headers, symbols, and macros
#include "uwbgl_Containers.h"
#include "uwbgl_IWindowHandler.h"     //Connection to a window
#include "uwbgl_WindowHandler2.h"
#include "uwbgl_Utility2.h"           //Utility functions
#include "uwbgl_Color1.h"
#include "uwbgl_Clock.h"

#include "uwbgl_D3DGraphicsSystem2.h" //D3D Graphics System Manager
#include "uwbgl_D3DWindowHandler3.h"  //Generic D3D Window base class

//geometry
#include "uwbgl_D3DCircleGeom2.h"
#include "uwbgl_D3DRectangleGeom2.h"