// University of Washington Bothell Graphics Library
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////
#pragma once
#include "uwbgl_Common.h"

/// Utility functions for general use

///
/// window that echo messages will be displayed on
extern HWND UWB_hEchoWindow;

/// Display a message on the "echo" window
/// \param message String to display on echo window
void UWB_EchoToStatusArea(const wchar_t* message);

/// Random number generator
/// \param range Returned number will be between 0 and range
/// \return a random number in the 0<->range range.
float UWB_RandomNumber(float range);

/// Random number generator
/// \return a random number between minRange and maxRange
float UWB_RandomNumber(float minRange, float maxRange);

/// Random number generator
/// \return three random numbers in the c-float array
void UWB_RandomTriple(float minRange, float maxRange, float c[3]);

/// Round a floating point value to nearest integer
/// \return the integer value of x
int UWB_Round(double x);
