#include "uwbgl_WindowHandler2.h"

UWB_WindowHandler::UWB_WindowHandler()
: m_hAttachedWindow(NULL)
{
}

UWB_WindowHandler::~UWB_WindowHandler()
{
}

bool UWB_WindowHandler::InitializeHandler(HWND hWindow)
{
  //check that the parameter is an actual window
  if(!::IsWindow(hWindow))
    return false;

  m_hAttachedWindow = hWindow;
  return true;
}

bool UWB_WindowHandler::HardwareToDevice(int hardwareX, int hardwareY, int& deviceX, int& deviceY) const
{
  if (!IsWindow(m_hAttachedWindow))
    return false;

  // x coordinate is the same
  deviceX = hardwareX;

  // transform is a flip of Y
  RECT rect;
  GetClientRect(m_hAttachedWindow, &rect);
  int client_height = rect.bottom - rect.top;
  deviceY = client_height - hardwareY;

  return true;
}

float UWB_WindowHandler::GetAspectRatio() const
{
  if (!IsWindow(m_hAttachedWindow))
    return 0.0f;;

  RECT rect;
  GetClientRect(m_hAttachedWindow, &rect);

  if((rect.bottom - rect.top) <= 0)
    return 0.0f;

  return (float)(rect.right - rect.left) / (float)(rect.bottom - rect.top);
}
